# NOTIFY.TCL Notify list for Eggdrops
# notify for IRC - by:Ec|ipse
# Email: tomas@primenet.com    HTTP://www.primenet.com/~tomas
# All feeback, errors, questions and suggestions welcome :)

# By Ec|ipse@EFnet (tomas@primenet.com) (C) 1997.. All rights reserved and such..
#
# PLEASE: Don't reproduce this without my name on any unmodified code. Try to give
#         me some recogniton for anything borrowed out of this script

# v1.0    08-20-97  tomas@primenet.com    from a request on eggdrop_mailing_list dated
#                                         some time ago.

# INSTRUCTIONS:
#   - commands consist of notify, whoson and whosin, type .notify help for
#     further instructions
#   - be sure to add the correct console flag, default is 5, to view notifies
# THINGS TO DO:
#   - whois support on those special friends

set time "45"           ;# how oftem bot will check for users
set flag "o"            ;# which partyline users can use notify
set loglev "5"          ;# log level to display notifies
set notify_status "1"   ;# current status of notify 0/1 (off/on)
#   note: all users with $flag can add and remove users from notifylist

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#      W A R N I N G      DON'T Change anything below here      W A R N I N G      #
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#

set notify_file notifylist.dat
set notify_list ""
set notifylist ""
set ison_list ""

if {![file exists $notify_file]} {
  global botnick
  set id [open $notify_file w]
  puts -nonewline $id "$botnick \n"
  close $id
}

proc open_notify_file {} {
  global notify_file notifylist
  set notify_list "" ; set notifylist ""
  set id [open $notify_file r]
  while {![eof $id]} {
    set entry [gets $id]
    if {$entry != ""} {
      lappend notifylist [lindex $entry 0]
      lappend notify_list "$entry"
    }
  }
  close $id
  return $notify_list
}

bind dcc $flag whoson dcc:whoson
proc dcc:whoson {hand idx arg} {
  global ison_list
  putcmdlog "#$hand# whoson"
  if {![info exists ison_list]} {
    putdcc $idx "*** No-one on your notify list is on IRC."
  } {
    putdcc $idx "*** Users on IRC: \[ [llength $ison_list] \] [chk4spec $ison_list]"
  }
  return 0
}

bind dcc $flag whosin dcc:whosin
proc dcc:whosin {hand idx arg} {
  global notifylist
  putcmdlog "#$hand# whosin"
  if {![info exists notifylist]} {
    putdcc $idx "*** Your notify list is currently empty."
  } {
    putdcc $idx "*** Users in Notifylist: \[ [llength $notifylist] \] [chk4spec $notifylist]"
  }
  return 0
}

bind dcc $flag notify dcc:notify
proc dcc:notify {hand idx arg} {
  global notify_file notifylist notify_status loglev
  putcmdlog "#$hand# notify $arg"
  switch [lindex [string tolower $arg] 0] {
    "on" {
      set notify_status 1
      putdcc $idx "*** Notify now \002Enabled\002"
    }
    "off" {
      set notify_status 0
      putdcc $idx "*** Notify now \002Disabled\002"
    }
    "add" {
      set nick [lindex $arg 1]
      if {[lindex $arg 2] == ""} {set type 0} {set type [lindex $arg 2]}
      if {![info exists notify_list]} {
        set notify_list [open_notify_file]
      }
      if {[lsearch [string tolower $notifylist] [string tolower $nick]] != -1} {
        putdcc $idx "*** Error, [join $nick] already exists on your notify list."
      } {
        foreach entry $notify_list {
          if {[string tolower [lindex $entry 0]] != [string tolower $nick]} {
            lappend new_notifylist "$entry" ; lappend notifylist [lindex $entry 0]
          }
        }
        lappend new_notifylist "$nick $type" ; lappend notifylist $nick
        set notify_list $new_notifylist
        set id [open $notify_file w]
        puts -nonewline $id [join $new_notifylist \n]
        close $id
        putdcc $idx "*** Added $nick to notify list."
        open_notify_file
      }
    }
    "rem" {
      set nick [lindex $arg 1]
      if {![info exists notify_list]} {
        set notify_list [open_notify_file]
      }
      if {[lsearch [string tolower $notifylist] [string tolower $nick]] == -1} {
        putdcc $idx "*** Error, [join $nick] is not on your notify list."
      } {
        foreach entry $notify_list {
          if {[string tolower [lindex $entry 0]] != [string tolower $nick]} {
            lappend new_notifylist "$entry" ; lappend notifylist [lindex $entry 0]
          }
        }
        set notify_list $new_notifylist
        set id [open $notify_file w]
        puts -nonewline $id [join $new_notifylist \n]
        close $id
        putdcc $idx "*** Removed $nick from notify list."
        open_notify_file
      }
    }
    "help" {
      putdcc $idx "\002Notify v1.0\002 by Ec|ipse <tomas@primenet.com>"
      putdcc $idx ""
      putdcc $idx "This script will keep track of users in an internal notifylist"
      putdcc $idx "and alert you when users are online, join IRC or leave IRC"
      putdcc $idx ""
      putdcc $idx "notify \002on\002 - will enable notify checking."
      putdcc $idx "notify \002off\002 - will disable notify checking."
      putdcc $idx "notify \002add\002 - will add a users nickname to the internal"
      putdcc $idx "   notifylist. by adding a 1 to the end ie: 'Ec|ipse 1' notify"
      putdcc $idx "   will perform a whois for address verification."
      putdcc $idx "notify \002rem\002 - will remove a users nickname from internal"
      putdcc $idx "   notifylist."
      putdcc $idx "whoson - will list the users currently on IRC from notifylist"
      putdcc $idx "whosin - will list the users currently in the notifylist"
    }
    default {
      if {$notify_status == 1} {
        putdcc $idx "*** Notify is currently \002Enabled\002"
      } {
        putdcc $idx "*** Notify is currently \002Disabled\002"
      }
      putdcc $idx "    Usage: /notify \[on|off|add|rem|help\] \[nickname\]"
    }
  }
  return 0
}

proc chk4spec {string} {
  regsub -all {\\} $string {\\\\} string
  regsub -all {\{} $string {\{} string
  regsub -all {\[} $string {\[} string
  regsub -all {\"} $string {\"} string
  return  $string
}

proc chk_notify {} {
  global time notify_status notifylist loglev
  if {$notify_status == 1} {putserv "ISON [chk4spec [join $notifylist]]"}
  utimer $time chk_notify
}

bind raw - "303" raw:303
proc raw:303 {from key raw} {
  global ison_list onirc_list notifylist notify_list loglev
  set irc_list ""
  set newlist [string trimleft [lrange $raw 1 end] :]
  if {![info exists ison_list]} {set ison_list ""}
  if {![info exists notify_list]} {set notify_list [open_notify_file]}
  foreach nick $newlist {
    if {[lsearch [string tolower $ison_list] [string tolower [chk4spec $nick]]] == -1} {
      lappend ison_list $nick
      putloglev $loglev * "\[\002Notify\002\] *** [chk4spec $nick] is on IRC"
      foreach entry $notify_list {
        if {[string tolower [lindex $entry 0]] == [string tolower $nick]} {
          if {[lindex $entry 1] == 1} {putserv "whois $nick"}
        }
      }
    }
  }
  if {$ison_list != ""} {
    if {[string match [string tolower $newlist] [string tolower $ison_list]] != "1"} {
      foreach nick $ison_list {
        if {[lsearch [string tolower $newlist] [string tolower $nick]] == -1} {
          if {[lsearch [string tolower $notifylist] [string tolower $nick]] != -1} {
            putloglev $loglev * "\[\002Notify\002\] *** [chk4spec $nick] has left IRC"
          }
        }
      }
      set ison_list $newlist
    }
  } {
    set ison_list $newlist
  }
}

foreach timer [utimers] {
  if {[lindex $timer 1] == "chk_notify"} {killutimer [lindex $timer 2]}
}

open_notify_file
utimer $time chk_notify

putlog "\"Internal Notify v1.0\" by: Ec|ipse loaded..."
